diff --git a/Client/Client/Assets/Scripts/UI/MapRenderer.cs b/Client/Client/Assets/Scripts/UI/MapRenderer.cs
new file mode 100644
index 0000000..2f7e498
--- /dev/null
+++ b/Client/Client/Assets/Scripts/UI/MapRenderer.cs
@@ -0,0 +1,305 @@
+﻿using System;
+using System.Collections;
+using System.Collections.Generic;
+using UnityEngine;
+using UnityEngine.UI;
+
+public class MapRenderer : MonoBehaviour
+{
+    [SerializeField]
+    public SceneManager sceneManager;
+
+    [SerializeField]
+    public Canvas labelCanvas;
+
+    [SerializeField]
+    public GameObject labelPrefab;
+
+    [SerializeField]
+    public GameObject smallLabelPrefab;
+
+    [SerializeField]
+    private SpriteRenderer underlayTemplate;
+
+    [SerializeField]
+    private SpriteRenderer overlayTemplate;
+
+    [SerializeField]
+    public bool interactable = true;
+
+    [SerializeField]
+    private Material UIMaterial;
+
+    [SerializeField] 
+    private Material overlayMaterial;
+
+    [SerializeField] 
+    private Material notAvailableMaterial;
+
+    [SerializeField] 
+    private Material UINotAvailableMaterial;
+
+    
+    public Color minColor;
+
+    public Color maxColor;
+
+
+    private Vector3 startPos;
+
+    private Vector3 startScale;
+
+
+    public SpriteRenderer underlay;
+
+    private Dictionary<string, SpriteRenderer> overlay = new Dictionary<string, SpriteRenderer>();
+
+    private Dictionary<string, Image> overlay2 = new Dictionary<string, Image>();
+    
+    private bool first = true;
+
+
+    // Start is called before the first frame update
+    void Start()
+    {
+        startPos = transform.position;
+        startScale = transform.localScale;
+        
+        Load();
+        interactable = true;
+    }
+
+    void Update()
+    {
+        if (first)
+        {
+            first = false;
+
+            // Get source directory
+            string sourceDirectory = sceneManager.mapSourceDirectory;
+
+            // Get file with asset relative positions
+            TextAsset output = Resources.Load<TextAsset>($"{sourceDirectory}/output");
+
+            if (output == null)
+            {
+                Debug.Log($"Layout file missing at {sourceDirectory}/output.csv. Returning.");
+                return;
+            }
+
+            string[] lines = output.ToString().Split('\n');
+            List<string> filenamesTMP = new List<string>();
+
+            for (int i = 0; i < lines.Length; i++)
+            {
+                lines[i] = lines[i].Trim();
+                if (lines[i].Length != 0 && !lines[i].StartsWith("//"))
+                    filenamesTMP.Add(lines[i]);
+            }
+
+            lines = filenamesTMP.ToArray();
+
+            for (int i = 0; i < lines.Length; i++)
+            {
+                var split = lines[i].Split(';');
+
+                // Parse name minus the extension
+                // X - percent offset from left btm corner
+                // Y - percent offset from left btm corner
+                var name = split[0].Substring(0, split[0].Length - 4);
+                var xoff = float.Parse(split[1]);
+                var yoff = float.Parse(split[2]);
+                var xmed = float.Parse(split[3]);
+                var ymed = float.Parse(split[4]);
+
+                var img = overlay[name];
+
+                if (img != null)
+                {
+                    var bounds = underlay.bounds;
+                    var imgbounds = img.bounds;
+
+                    var xshift = -bounds.size.x / 2 + imgbounds.size.x / 2 + bounds.size.x * (xoff / 100);
+                    var yshift = -bounds.size.y / 2 + imgbounds.size.y / 2 + bounds.size.y * (yoff / 100);
+
+                    var xmedshift = -bounds.size.x / 2 + imgbounds.size.x / 2 + bounds.size.x * (xmed / 100);
+                    var ymedshift = -bounds.size.y / 2 + imgbounds.size.y / 2 + bounds.size.y * (ymed / 100);
+
+                    img.gameObject.transform.position = bounds.center + new Vector3(xshift, yshift, 0);
+
+                    var label = Instantiate(labelPrefab, labelCanvas.transform);
+                    var labelText = label.GetComponentInChildren<Text>();
+                    var labelPanel = label.gameObject.GetComponentInChildren<HorizontalLayoutGroup>();
+                    labelText.text = name.ToUpper();
+                    label.name = labelText.text;
+
+                    BuildingPanel.aliases.Add(name, img);
+
+                    for (int si = 5; si < split.Length; si++)
+                    {
+                        var smallLabel = Instantiate(smallLabelPrefab, labelPanel.transform);
+                        var smallLabelText = smallLabel.GetComponentInChildren<Text>();
+                        smallLabelText.text = split[si].ToUpper();
+                        smallLabel.name = smallLabelText.text;
+                        BuildingPanel.aliases.Add(split[si], img);
+                    }
+
+                    PositionUpdater posup = label.GetComponent<PositionUpdater>();
+                    posup.source = img.gameObject;
+
+                    RectTransform rect = label.GetComponent<RectTransform>();
+                    Vector3 newPosition = Camera.main.WorldToScreenPoint(bounds.center + new Vector3(xmedshift, ymedshift, 0));
+                    rect.position = newPosition;
+                }
+                else
+                {
+                    Debug.Log($"Error: Missing sprite {name}!");
+                }
+            }
+        }
+    }
+
+    /// <summary>
+    /// Loads map resources from an annotated directory
+    /// A "layout.txt" file with directory annotation is required
+    /// Creates the underlay map and building overlays addressable by their name as per the layout file
+    /// </summary>
+    /// <param name="sourceDirectory">Path to the source directory</param>
+    public void Load()
+    {
+        // Get source directory
+        string sourceDirectory = sceneManager.mapSourceDirectory;
+
+        // Load directory layout
+        // Read filenames
+        // First filename is the underlay
+        // All the others are the overlays, names as their respective building codes
+        TextAsset layout = Resources.Load<TextAsset>($"{sourceDirectory}/layout");
+
+        if (layout == null)
+        {
+            Debug.Log($"Layout file missing at {sourceDirectory}/layout.txt. Returning.");
+            return;
+        }
+
+        string[] filenames = layout.ToString().Split('\n');
+
+        // A map must contain at least an underlay
+        if (filenames.Length < 1)
+        {
+            Debug.Log("Attempted to load an empty map. Returning.");
+            return;
+        }
+
+        // Trim filenames (line breaks), remove empty line breaks and comments
+        List<string> filenamesTMP = new List<string>();
+        
+        for (int i = 0; i < filenames.Length; i++)
+        {
+            filenames[i] = filenames[i].Trim();
+            if (filenames[i].Length != 0 && !filenames[i].StartsWith("//"))
+                filenamesTMP.Add(filenames[i]);
+        }
+
+        filenames = filenamesTMP.ToArray();
+
+        // Load underlay sprite
+        Sprite underlaySprite = Resources.Load<Sprite>($"{sourceDirectory}/{filenames[0]}");
+
+        if (underlaySprite == null)
+        {
+            Debug.LogError($"Underlay sprite does not exist at path \"{sourceDirectory}/{filenames[0]}.png\". Returning.");
+            return;
+        }
+
+        // Load overlay sprites
+        Sprite[] overlaySprites = new Sprite[filenames.Length - 1];
+
+        for (int i = 1; i < filenames.Length; i++)
+        {
+            overlaySprites[i-1] = Resources.Load<Sprite>($"{sourceDirectory}/{filenames[i]}");
+            
+            if (overlaySprites[i - 1] == null)
+            {
+                Debug.LogError($"Overlay sprite does not exist at path \"{sourceDirectory}/{filenames[i]}.png\". Returning.");
+                return;
+            }
+        }
+
+        // Create game objects
+        underlay = Instantiate(underlayTemplate, transform);
+        underlay.name = "Underlay";
+        underlay.sprite = underlaySprite;
+
+        for (int i = 1; i < filenames.Length; i++)
+        {
+            overlay[filenames[i]] = Instantiate(overlayTemplate, transform);
+            overlay[filenames[i]].name = filenames[i];
+            overlay[filenames[i]].sprite = overlaySprites[i - 1];
+            overlay[filenames[i]].sortingOrder = i;
+        }
+
+        // Get references to remaining building sprites
+        BuildingTag[] images = (FindObjectsOfType(typeof(BuildingTag)) as BuildingTag[]);
+        foreach (var building in images)
+        {
+            overlay2[building.builidngName] = building.GetComponent<Image>();
+            //Debug.Log(building.builidngName);
+        }
+    }
+
+    public void SetColors(double[] predictions)
+    {
+        var buildings = Buildings.buildings;
+
+        if (predictions.Length != buildings.Length)
+        {
+            Debug.LogError("Mismatch in prediction and building count.");
+            return;
+        }
+
+        for (int i = 0; i < buildings.Length; i++)
+        {
+            if (predictions[i] < 0)
+            {
+                if (overlay.ContainsKey(buildings[i]))
+                {
+                    overlay[buildings[i]].material = notAvailableMaterial;
+
+                }
+                else if (overlay2.ContainsKey(buildings[i]))
+                {
+                    overlay2[buildings[i]].material = UINotAvailableMaterial;
+                }
+            }
+
+            else
+            {
+                if (overlay.ContainsKey(buildings[i]))
+                {
+                    float a = overlay[buildings[i]].color.a;
+                    var c = Color.Lerp(minColor, maxColor, (float)predictions[i] / 100f);
+                    c.a = a;
+                    overlay[buildings[i]].color = c;
+                    overlay[buildings[i]].material = overlayMaterial;
+                }
+
+                else if (overlay2.ContainsKey(buildings[i]))
+                {
+                    RectTransform rt = overlay2[buildings[i]].GetComponent(typeof(RectTransform)) as RectTransform;
+                    rt.SetSizeWithCurrentAnchors(RectTransform.Axis.Horizontal, 25 + (200 * ((float)predictions[i] / 100f)));
+                    rt.ForceUpdateRectTransforms();
+
+                    float a = overlay2[buildings[i]].color.a;
+                    var c = Color.Lerp(minColor, maxColor, (float)predictions[i] / 100f);
+                    c.a = a;
+                    overlay2[buildings[i]].color = c;
+                    overlay2[buildings[i]].material = UIMaterial;
+                }
+
+            }
+        }
+
+    }
+
+}
diff --git a/Client/Client/Assets/Scripts/UI/MapRenderer.cs.meta b/Client/Client/Assets/Scripts/UI/MapRenderer.cs.meta
new file mode 100644
index 0000000..5a66257
--- /dev/null
+++ b/Client/Client/Assets/Scripts/UI/MapRenderer.cs.meta
@@ -0,0 +1,11 @@
+fileFormatVersion: 2
+guid: 03f66542357dc45478e44afc56b689fe
+MonoImporter:
+  externalObjects: {}
+  serializedVersion: 2
+  defaultReferences: []
+  executionOrder: 0
+  icon: {instanceID: 0}
+  userData: 
+  assetBundleName: 
+  assetBundleVariant: 
diff --git a/Client/Client/Assets/Scripts/UI/NetworkingManager.cs b/Client/Client/Assets/Scripts/UI/NetworkingManager.cs
new file mode 100644
index 0000000..be012be
--- /dev/null
+++ b/Client/Client/Assets/Scripts/UI/NetworkingManager.cs
@@ -0,0 +1,104 @@
+﻿using System.Collections;
+using System.Collections.Generic;
+using UnityEngine;
+using UnityEngine.Networking;
+using System.Security.Cryptography.X509Certificates;
+
+public class NetworkingManager : MonoBehaviour
+{
+    public RushManager rushManager;
+    
+    public string uri = "https://147.228.173.54:10000/";
+
+    public void StartPost(Request request)
+    {
+        StartCoroutine(Post(uri, XmlCommunication.Serialize(request)));
+
+        // Mock response:
+        // StartCoroutine(Get(uri));
+    }
+
+    public void StartGet()
+    {
+        StartCoroutine(Get(uri));
+    }
+
+    public void StartWeatherGet(WeatherProvider weatherProvider, string uri)
+    {
+        StartCoroutine(WeatherGet(weatherProvider, uri));
+    }
+
+    IEnumerator Post(string uri, string toPost)
+    {
+        Debug.Log("Uploading: " + toPost);
+        UnityWebRequest www = UnityWebRequest.Post(uri, toPost);
+        www.certificateHandler = new AcceptAllCertificates();
+        yield return www.SendWebRequest();
+
+        if (www.isNetworkError || www.isHttpError)
+        {
+            Debug.Log(www.error);
+        }
+        else
+        {
+            // Show results as text
+            Debug.Log("Upload complete!");
+
+            var xml = www.downloadHandler.text;
+
+            Debug.Log(xml);
+
+            rushManager.SetResponse(XmlCommunication.Deserialize<Response>(xml));
+
+            Debug.Log("Response received!");
+        }
+    }
+
+    IEnumerator Get(string uri)
+    {
+        Debug.Log("Downloading...");
+        UnityWebRequest www = UnityWebRequest.Get(uri);
+        www.certificateHandler = new AcceptAllCertificates();
+        yield return www.SendWebRequest();
+
+        if (www.isNetworkError || www.isHttpError)
+        {
+            Debug.Log(www.error);
+        }
+        else
+        {
+            // Show results as text
+            var xml = www.downloadHandler.text;
+            rushManager.SetResponse(XmlCommunication.Deserialize<Response>(xml));
+            Debug.Log(xml);
+        }
+    }
+
+    IEnumerator WeatherGet(WeatherProvider weatherProvider, string uri)
+    {
+        Debug.Log("Downloading weather...");
+        UnityWebRequest www = UnityWebRequest.Get(uri);
+        www.certificateHandler = new AcceptAllCertificates();
+        yield return www.SendWebRequest();
+
+        if (www.isNetworkError || www.isHttpError)
+        {
+            Debug.Log(www.error);
+        }
+        else
+        {
+            // Show results as text
+            var weather = www.downloadHandler.text;
+            weatherProvider.LoadFromResponse(weather);
+            Debug.Log(weather);
+        }
+    }
+
+    public class AcceptAllCertificates : CertificateHandler
+    {
+        protected override bool ValidateCertificate(byte[] certificateData)
+        {
+            return true;
+        }
+    }
+}
diff --git a/Client/Client/Assets/Scripts/UI/NetworkingManager.cs.meta b/Client/Client/Assets/Scripts/UI/NetworkingManager.cs.meta
new file mode 100644
index 0000000..572a696
--- /dev/null
+++ b/Client/Client/Assets/Scripts/UI/NetworkingManager.cs.meta
@@ -0,0 +1,11 @@
+fileFormatVersion: 2
+guid: 293c714f76f64e2409990ec2bc9368c6
+MonoImporter:
+  externalObjects: {}
+  serializedVersion: 2
+  defaultReferences: []
+  executionOrder: 0
+  icon: {instanceID: 0}
+  userData: 
+  assetBundleName: 
+  assetBundleVariant: 
diff --git a/Client/Client/Assets/Scripts/UI/RushManager.cs b/Client/Client/Assets/Scripts/UI/RushManager.cs
new file mode 100644
index 0000000..568cc80
--- /dev/null
+++ b/Client/Client/Assets/Scripts/UI/RushManager.cs
@@ -0,0 +1,211 @@
+﻿using System;
+using System.Collections;
+using System.Collections.Generic;
+using UnityEngine;
+
+public class RushManager : MonoBehaviour
+{
+    private DateTimeManager dateTimeManager;
+    private WeatherManager weatherManager;
+    public NetworkingManager networkingManager;
+    public MapRenderer mapRenderer;
+
+    private Request request;
+    private Response response;
+
+    private Prediction currentPrediction;
+    public int predictionIndex;
+
+    public bool playing = false;
+    private bool loading = false;
+
+    public Animator loadingAnimator;
+
+    public float timePerSegment = 1f;
+    public float timer;
+
+    // Start is called before the first frame update
+    void Start()
+    {
+        dateTimeManager = GetComponent<DateTimeManager>();
+        weatherManager = GetComponent<WeatherManager>();
+    }
+
+    // Update is called once per frame
+    void Update()
+    {
+        // No request made yet, no response received
+        // If there is no request and no response, new request should be made
+        if (request == null && response == null)
+        {
+            request = new Request();
+            request.start = dateTimeManager.currentDate;
+            weatherManager.SetWeather(request);
+            networkingManager.StartPost(request);
+        }
+        
+        // No request, response received - playing animation
+        else if (request == null && response != null)
+        {
+            if (loading)
+            {
+                loading = false;
+                if (loadingAnimator != null) 
+                    loadingAnimator.SetBool("loading", loading);
+            }
+
+            if (playing)
+            {
+                timer -= Time.deltaTime;
+                if (timer < 0)
+                {
+                    timer = timePerSegment;
+
+                    if (predictionIndex + 1 < response.predicitons.Length)
+                    {
+                        Next();
+                        playing = true; //  Correct for Next() setting playing = false
+                    }
+                    else
+                    {
+                        playing = false;
+                    }
+                }
+            }
+        }
+
+        // Request made, waiting for response
+        else if (request != null && response == null)
+        {
+            // Play loading animation
+            if (!loading)
+            {
+                loading = true;
+                if (loadingAnimator != null) 
+                    loadingAnimator.SetBool("loading", loading);
+                mapRenderer.SetColors(new double[Buildings.buildings.Length]);
+            }
+            //Debug.Log("Loading...");
+        }
+
+        else if (request != null && response != null)
+        {
+            Debug.LogError("Coexisting request and response. This should never happen.");
+        }
+
+    }
+
+    public void SetResponse(Response response)
+    {
+        this.request = null;
+        this.response = response;
+        currentPrediction = response.predicitons[0];
+        predictionIndex = 0;
+        Redraw();
+    }
+
+    public void CreateRequest(Date startDate, Date endDate, bool useOwnWeather)
+    {
+        this.response = null;
+        
+        request = new Request();
+        request.start = startDate;
+        request.useEndDate = endDate != null;
+        request.end = endDate;
+
+        weatherManager.SetWeather(request, useOwnWeather);
+        networkingManager.StartPost(request);
+    }
+
+    public void Play(bool play)
+    {
+        // Works as a play/pause toggle
+        if (response == null) { Debug.LogError("Trying to access null response/prediction."); return; }
+        playing = play;
+        timer = timePerSegment;
+
+        if (predictionIndex + 1 == response.predicitons.Length)
+        {
+            predictionIndex = 0;
+            currentPrediction = response.predicitons[0];
+            Redraw();
+        }
+    }
+
+    public void First()
+    {
+        if (response == null) { Debug.LogError("Trying to access null response/prediction."); return; }
+
+        playing = false;
+        currentPrediction = response.predicitons[0];
+        predictionIndex = 0;
+        Redraw();
+    }
+
+    public void Last()
+    {
+        if (response == null) { Debug.LogError("Trying to access null response/prediction."); return; }
+
+        playing = false;
+        currentPrediction = response.predicitons[response.predicitons.Length - 1];
+        predictionIndex = response.predicitons.Length - 1;
+        Redraw();
+    }
+
+    public void Previous()
+    {
+        if (response == null) { Debug.LogError("Trying to access null response/prediction."); return; }
+        
+        playing = false;
+
+        int newIndex = predictionIndex - 1;
+
+        if (newIndex == -1)
+            return;
+        predictionIndex = newIndex;
+        currentPrediction = response.predicitons[predictionIndex];
+        Redraw();
+    }
+
+    public void Next()
+    {
+        if (response == null) { Debug.LogError("Trying to access null response/prediction."); return; }
+        
+        playing = false;
+
+        int newIndex = predictionIndex + 1;
+        if (newIndex == response.predicitons.Length)
+            return;
+        predictionIndex = newIndex;
+        currentPrediction = response.predicitons[predictionIndex];
+        Redraw();
+    }
+
+    public void ResetRush()
+    {
+        playing = false;
+        response = null;
+        currentPrediction = null;
+        predictionIndex = -1;
+        // If there is no request and no response, new request should be made in Update
+    }
+
+    public float GetProgress()
+    {
+        if (response == null) { Debug.LogError("Trying to access null response/prediction."); return 0f; }
+
+        if ((response.predicitons.Length - 1) == 0) return 1.0f;
+        return predictionIndex / (float)(response.predicitons.Length - 1);
+    }
+
+    private void Redraw()
+    {
+        var firstPred = response.predicitons[0];
+        var lastPred = response.predicitons[response.predicitons.Length-1];
+
+        dateTimeManager.SetDates(currentPrediction.dateTime, firstPred.dateTime, lastPred.dateTime);
+        weatherManager.SetDateTime(currentPrediction.dateTime);
+        mapRenderer.SetColors(currentPrediction.predictions);
+    }
+
+}
diff --git a/Client/Client/Assets/Scripts/UI/RushManager.cs.meta b/Client/Client/Assets/Scripts/UI/RushManager.cs.meta
new file mode 100644
index 0000000..18e0dbe
--- /dev/null
+++ b/Client/Client/Assets/Scripts/UI/RushManager.cs.meta
@@ -0,0 +1,11 @@
+fileFormatVersion: 2
+guid: 7aaba704d6fddc649b36d23259367344
+MonoImporter:
+  externalObjects: {}
+  serializedVersion: 2
+  defaultReferences: []
+  executionOrder: 0
+  icon: {instanceID: 0}
+  userData: 
+  assetBundleName: 
+  assetBundleVariant: 
diff --git a/Client/Client/Assets/Scripts/UI/SceneManager.cs b/Client/Client/Assets/Scripts/UI/SceneManager.cs
new file mode 100644
index 0000000..fa698d2
--- /dev/null
+++ b/Client/Client/Assets/Scripts/UI/SceneManager.cs
@@ -0,0 +1,42 @@
+﻿using System.Collections;
+using System.Collections.Generic;
+using UnityEngine;
+
+public class SceneManager : MonoBehaviour
+{
+    [SerializeField]
+    public string mapSourceDirectory;
+
+    public GameObject weatherPanel;
+    public GameObject datePanel;
+    public GameObject buildingPanel;
+    public GameObject animationPanel;
+    public GameObject aboutPanel;
+
+    public bool first;
+
+    // Start is called before the first frame update
+    void Start()
+    {
+        first = true;
+        weatherPanel.SetActive(true);
+        datePanel.SetActive(true);
+        buildingPanel.SetActive(true);
+        animationPanel.SetActive(true);
+        aboutPanel.SetActive(true);
+    }
+
+    // Update is called once per frame
+    void Update()
+    {
+        if (first)
+        {
+            weatherPanel.SetActive(false);
+            datePanel.SetActive(false);
+            buildingPanel.SetActive(false);
+            animationPanel.SetActive(false);
+            aboutPanel.SetActive(false);
+            first = false;
+        }
+    }
+}
diff --git a/Client/Client/Assets/Scripts/UI/SceneManager.cs.meta b/Client/Client/Assets/Scripts/UI/SceneManager.cs.meta
new file mode 100644
index 0000000..2614067
--- /dev/null
+++ b/Client/Client/Assets/Scripts/UI/SceneManager.cs.meta
@@ -0,0 +1,11 @@
+fileFormatVersion: 2
+guid: 833f84acfa541974ebffb9dab10cb27c
+MonoImporter:
+  externalObjects: {}
+  serializedVersion: 2
+  defaultReferences: []
+  executionOrder: 0
+  icon: {instanceID: 0}
+  userData: 
+  assetBundleName: 
+  assetBundleVariant: 
diff --git a/Client/Client/Assets/Scripts/UI/WebGLMapController.cs b/Client/Client/Assets/Scripts/UI/WebGLMapController.cs
new file mode 100644
index 0000000..9cbd9ee
--- /dev/null
+++ b/Client/Client/Assets/Scripts/UI/WebGLMapController.cs
@@ -0,0 +1,195 @@
+﻿// Tutorial: http://coffeebreakcodes.com/drag-object-with-mouse-unity3d/
+
+using System.Collections;
+using System.Collections.Generic;
+using UnityEngine;
+using UnityEngine.EventSystems;
+
+public class WebGLMapController : MonoBehaviour
+{
+	[SerializeField]
+	private MapRenderer map;
+
+	[SerializeField]
+	private float zoomSpeed;
+
+	[SerializeField]
+	private float minScale = 0.5f;
+	
+	[SerializeField]
+	private float maxScale = 1f;
+
+	private Vector3 originalPos;
+	private Vector3 screenPoint;
+	private Vector3 offset;
+
+    public bool block;
+	public bool blockExternal;
+
+	void Start()
+	{
+		originalPos = map.transform.position;
+	}
+
+	void Update()
+	{
+		ClampPan();
+	}
+
+    void OnMouseDown()
+	{
+		if (!map.interactable || block || blockExternal) return;
+		if (EventSystem.current.IsPointerOverGameObject())
+        {
+			block = true;
+            return;
+        }
+
+		screenPoint = Camera.main.WorldToScreenPoint(map.transform.position);
+		offset = map.transform.position - Camera.main.ScreenToWorldPoint(new Vector3(Input.mousePosition.x, Input.mousePosition.y, screenPoint.z));
+	}
+
+	void OnMouseDrag()
+	{
+		if (!map.interactable || block || blockExternal) return;
+
+		Vector3 cursorPoint = new Vector3(Input.mousePosition.x, Input.mousePosition.y, screenPoint.z);
+		Vector3 cursorPosition = Camera.main.ScreenToWorldPoint(cursorPoint) + offset;
+		map.transform.position = cursorPosition;
+		ClampPan();
+	}
+
+    private void OnMouseOver()
+	{
+		if (!map.interactable || block || blockExternal) return;
+		if (EventSystem.current.IsPointerOverGameObject())
+			return;
+
+		var scroll = Input.mouseScrollDelta.y;		
+		float step = Time.deltaTime * zoomSpeed;
+		float scale = map.transform.localScale.x;
+
+		var xnorm = map.transform.position.x / scale;
+		var ynorm = map.transform.position.y / scale;
+
+		if (scroll > 0)
+			scale = ClampScale(scale + step);
+		else if (scroll < 0)
+			scale = ClampScale(scale - step);
+		
+		Vector3 localScale = new Vector3(scale, scale, 1);
+		map.transform.localScale = localScale;
+		map.transform.position = new Vector3(xnorm * scale, ynorm * scale, map.transform.position.z);
+
+		ClampPan();
+	}
+
+    public void OnMouseUp()
+    {
+		block = false;
+    }
+
+    private void ClampPan()
+	{
+		var bounds = map.transform.Find("Underlay").GetComponent<SpriteRenderer>().sprite.bounds;
+		bounds = TransformBounds(bounds, map.transform.localScale);
+
+		var screenMin = Camera.main.WorldToScreenPoint(bounds.min + map.transform.position);
+		var screenMax = Camera.main.WorldToScreenPoint(bounds.max + map.transform.position);
+
+		float shiftX = 0f;
+		float shiftY = 0f;
+
+		var mapWidth = screenMax.x - screenMin.x;
+		var mapHeight = screenMax.y - screenMin.y;
+
+		bool wider = mapWidth >= Camera.main.pixelWidth;
+		bool taller = mapHeight >= Camera.main.pixelHeight;
+
+		if (wider)
+        {
+			if (screenMin.x > 0)
+				shiftX -= screenMin.x;
+
+			if (screenMax.x < Camera.main.pixelWidth)
+				shiftX += Camera.main.pixelWidth - screenMax.x;
+		}
+
+		if (taller)
+		{
+			if (screenMin.y > 0)
+				shiftY -= screenMin.y;
+
+			if (screenMax.y < Camera.main.pixelHeight)
+				shiftY += Camera.main.pixelHeight - screenMax.y;
+		}
+
+		var screenCenter = Camera.main.WorldToScreenPoint(map.transform.position);
+		screenCenter.x += shiftX;
+		screenCenter.y += shiftY;
+		map.transform.position = Camera.main.ScreenToWorldPoint(screenCenter);
+
+		if (wider && taller)
+        {
+			// Nothing to do, the position is correct
+		}
+		else if (taller)
+        {
+			// Set original x coord
+			map.transform.position = new Vector3(
+				originalPos.x,
+				map.transform.position.y,
+				map.transform.position.z);
+		}
+		else if (wider)
+        {
+			// Set original y coord
+			map.transform.position = new Vector3(
+				map.transform.position.x,
+				originalPos.y,
+				map.transform.position.z);
+		}
+		else
+        {
+			// Set original position but this should not happen
+			map.transform.position = originalPos;
+		}
+		
+	}
+
+	private float ClampScale(float scale)
+    {
+		return Mathf.Min(Mathf.Max(scale, minScale), maxScale);
+	}
+
+	private Bounds TransformBounds(Bounds bounds, Vector3 scale)
+	{
+		var size = bounds.size;
+
+		size.x *= scale.x;
+		size.y *= scale.y;
+		size.z *= scale.z;
+
+		return new Bounds(bounds.center, size);
+	}
+
+	public void ZoomOn(SpriteRenderer sprite)
+	{
+		if (sprite == null)
+        {
+			Debug.LogError("Zooming on null spriteRenderer. Skipping operation.");
+			return;
+        }
+
+		Vector3 localScale = new Vector3(maxScale, maxScale, 1);
+		map.transform.localScale = localScale;
+
+		var from = Camera.main.ViewportToWorldPoint(new Vector3(0.5f, 0.5f, 10f));
+		var to = sprite.transform.position;
+
+		map.transform.position = map.transform.position - (to - from);
+	
+		ClampPan();
+	}
+
+}
diff --git a/Client/Client/Assets/Scripts/UI/WebGLMapController.cs.meta b/Client/Client/Assets/Scripts/UI/WebGLMapController.cs.meta
new file mode 100644
index 0000000..fd58de5
--- /dev/null
+++ b/Client/Client/Assets/Scripts/UI/WebGLMapController.cs.meta
@@ -0,0 +1,11 @@
+fileFormatVersion: 2
+guid: 379fb18718ee0f2469e5c60a36b96218
+MonoImporter:
+  externalObjects: {}
+  serializedVersion: 2
+  defaultReferences: []
+  executionOrder: 0
+  icon: {instanceID: 0}
+  userData: 
+  assetBundleName: 
+  assetBundleVariant: 
diff --git a/Client/Client/Assets/Scripts/Weather/WeatherData.cs b/Client/Client/Assets/Scripts/Weather/WeatherData.cs
index 6590199..5ad3490 100644
--- a/Client/Client/Assets/Scripts/Weather/WeatherData.cs
+++ b/Client/Client/Assets/Scripts/Weather/WeatherData.cs
@@ -3,15 +3,46 @@ using System.Collections;
 using System.Collections.Generic;
 using UnityEngine;
 
+/// <summary>
+/// Weather data container
+/// 
+/// Author: kacerekz
+/// 
+/// </summary>
 public class WeatherData
 {
+    /// <summary>
+    /// Observers to changes in the data
+    /// </summary>
     private List<WeatherObserver> observers = new List<WeatherObserver>();
 
+    /// <summary>
+    /// Temperature
+    /// </summary>
     public double Temperature { get; private set; }
+    
+    /// <summary>
+    /// Wind speed
+    /// </summary>
     public double Wind { get; private set; }
+    
+    /// <summary>
+    /// Rain probability
+    /// </summary>
     public double Rain { get; private set; }
+    
+    /// <summary>
+    /// Weather condition
+    /// </summary>
     public WeatherConditions Weather { get; private set; }
 
+    /// <summary>
+    /// Value setter
+    /// </summary>
+    /// <param name="temperature">Temperature to set</param>
+    /// <param name="wind">Wind speed to set</param>
+    /// <param name="rain">Rain probability to set</param>
+    /// <param name="weather">Weather condition to set</param>
     public void SetValues(double temperature, double wind, double rain, WeatherConditions weather)
     {
         Temperature = temperature;
@@ -25,6 +56,10 @@ public class WeatherData
             observer.Notify(this);
     }
 
+    /// <summary>
+    /// Registers an observer
+    /// </summary>
+    /// <param name="observer">A WeatherObserver to register</param>
     public void RegisterObserver(WeatherObserver observer)
     {
         observers.Add(observer);
